
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.Scanner;

public abstract class KFx3cc {
	int ref = 10000; // Hardware Reference frequency 10/12.5 kHz or 5/6.25 kHz
	
	protected abstract int[] generateRX( long rx );

	protected abstract int[] generateTX( long tx );

	private void toIntelHex( int a, int[] b ){
		int check = 0;
		System.out.printf( ":%02x%04x00", new Object[] { new Integer( b.length ), new Integer( a )});
		check += (byte) 0xff & b.length;
		check += (byte) 0xff & ( a );
		check += (byte) 0xff & ( a >> 8 );
		for( int i = 0; i < b.length; i++ ){
			System.out.printf( "%02x", new Object[] { new Integer( b[i] )});
			check += (byte) 0xff & b[i];
		}
		check = - check;
		System.out.printf( "%02x", new Object[] { new Integer( 0xff & check )}); 
		System.out.println();
	}
	
	private void IntelHexEnd(){
		System.out.println( ":00000001ff" );
	}
	
	public static void main(String[] args) {
		BufferedReader in = null;
		String line = null;
		KFx3cc cc = null;
		int channel = 0;
		int[] b = null;

		try{
			in = new BufferedReader( new FileReader( "channel.txt" ));
			if(( line = in.readLine()) != null ){
				if( line.startsWith( "KF-83" )) cc = new KF83cc();
				else if( line.startsWith( "KF-163" )) cc = new KF163cc();
//				else if( line.startsWith( "KF-453" )) cc = new KF453cc();
				else if( line.startsWith( "HFG-84" )) cc = new HFG84cc();
				else if( line.startsWith( "HFG-164" )) cc = new HFG164cc();
			}
			if( cc == null ) return;
			while(( line = in.readLine()) != null ){
				if( line.startsWith( "#" ));
				else if( line.startsWith( "R5" )) cc.ref = 5000;
				else {
					Scanner s = new Scanner( line ).useDelimiter( ", *" );
					if( s.hasNextShort() ){
						channel = (short) ( s.nextShort() );
						b = cc.generateRX( s.nextLong());
						cc.toIntelHex( channel * 4, b );
						b = cc.generateTX( s.nextLong());
						cc.toIntelHex( channel * 4 + 128, b );
					}
				}
			}
			cc.IntelHexEnd();
			in.close();
		} catch( IOException e ){
			e.printStackTrace();
		}
	}
}
